// ledc28v2.c:  blink led on RB pin 0 -- simple SX C program for CC1B compiler
//		based on ledc28.c
//                 C program similar to led28.src (assemlber for SX)

// this version of ledc28.c shows the use of the rather obcure, but useful, /*<?asm 
// and ?>*/ pair.  look in main() function to see them used to insert a 'not RB' SX
// instruction

// any lines between them will be inserted into the assembler file, the ".src" file, for
// the SX-KEY

// note:
// these pairs can also be used at add the SX device settings in leu of using the
// CC1B2SX.HDR file

#pragma chip SX28 // select device

// to have these lines between /*<#asm and #>*/ passed directly to the SX-KEY,
// change the /*<#asm and #>*/ respecitvely to /*<?asm and ?>*/
// ( in other words, change the two '#' chars to '?'.
// also, rename the CC1B2SX.HDR file to something like CC1B2SX-nop.HDR so that the
// device settings are not added twice!!!
/*<#asm
	DEVICE OSCHS3
	IRC_CAL IRC_FAST
	FREQ	50_000_000
	RESET	main
	ID	'project'
#>*/

// ************************************************
// ************************************************
// MACRO DEFINITIONS AND CONSTANTS

#define MAX_COUNT1 5
#define MAX_COUNT2 255
#define MAX_COUNT3 255
 
// ************************************************
// ************************************************
// IO PORT DEFINITIONS

bit pinB0 @ RB.0;

// ************************************************
// ************************************************
// GLOBAL VARIABLE DEFINITIONS

#pragma rambank 0
// unsigned char Count1, Count2;          // located in ram bank 0

#pragma rambank 2


// ************************************************
// ************************************************
// PROTOTYPES AND CODEPAGES

/* Prototypes are needed when a function is called before it
is defined. It can also be used for fine tuning the code
layout (i.e. which codepage to use for a function). */

void delay( void);
page2 char function2( void);



// ************************************************
// ************************************************
// INTERRUPT SUPPORT

#pragma origin 0   // interrupt must be located first on codepage 0

interrupt iServer(void)
{
    /* NOTE: W, STATUS and FSR are automatically saved to
       and restored from shadow registers */

    nop();
}



// ************************************************
// ************************************************
// INCLUDED C FILES AND MATH ROUTINES

// none in this program

#pragma codepage 0

// ************************************************
// ************************************************
// C FUNCTIONS


void delay( void)
{
	unsigned char Count1, Count2, Count3;  
	for (Count1 = MAX_COUNT1; Count1 != 0; Count1--) {
		for (Count2 = MAX_COUNT2; Count2 != 0; Count2--) {
			for (Count3 = MAX_COUNT3; Count3 != 0; Count3--) {
			// do nothing
			}
		}
	}
	
	return;

}


void main(void)
{

	// OPTION = 0xa8;  // ints off!
	
    clearRAM();  // built in function
#if 0
	
	    // configure 8-bit RB, all outputs
	TRISB = 0x00;   // all pins output
	LVL_B = 0xff;   // all TTL voltages
    ST_B = 0xff;    // schmitt triggers off
    PLP_B = 0xff;   // pull-ups off
    WKEN_B = 0xff;  // Wake up disabled
    WKED_B = 0xff;  // Wake up falling edge

    // configure 8-bit RC, all outputs
	TRISC = 0x00;   // all pins output
	LVL_C = 0xff;   // all TTL voltages
    ST_C = 0xff;    // schmitt triggers off
    PLP_C = 0xff;   // pull-ups off

    RB = 0xff;      // all LEDs off!
	
#endif
	
	bank0 unsigned char hold;
	bit holdB0 @ hold.0;	
	// bank1 char c;

	TRISB = 0xfe;   // %1111 1110
	RB = 0;
	while (1) {

	  delay();
	  // holdB0 = pinB0;
	  // hold++;
	  // pinB0 = holdB0;
	  // use assmebler 'not' instruction to toggle RB bits
	  	/*<?asm
		not RB
		?>*/
	}
	



}
	



